<?php

/* ----------------------------------------------------------------------------------
 * 
 * Xaseco plugin to display a RSS feed
 *
 * ----------------------------------------------------------------------------------
 *
 * Author: 			nouseforname @ http://www.tm-forum.com
 * Home: 			nouseforname.de
 * Date: 			12.105.2012
 * Version:			1.1.1
 * Dependencies: 	none
 *
 * ----------------------------------------------------------------------------------
 *
 * LICENSE: This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * ----------------------------------------------------------------------------------
 */

class NouseRSSReader {

	/********************   config start    **************************/
	
	// link to RSS file
	private $rssfeed = 'http://www.worldcup2010southafrica.com/rss.feed'; 
	//private $rssfeed = 'http://www.sport1.de/de_1/fussball/rss.xml';
	
	// title above the RSS Feeds
	private $title = '$o$f21$sWorldcup News:';	
	
	// colorcode for news feeds
	private $color = '$n$o$11f';	
	
	// main position x y of whole manialink
	private $pos = '-47 -15.0';	
	
	// count of news to display
	private $count = 3;	 
	
	/********************   config end     **************************/
	
	var $active_players = array(), $inactive_players = array();
	var $items = array();
	private $atom;
	
    function upToDate($aseco) {
        $aseco->plugin_versions[] = array(
            'plugin'	=> 'plugin.nouse.rssreader.php',
            'author'	=> 'Nouseforname',
            'version'	=> '1.1.1'
        );
    }
	// startup 
	function startUp($aseco){
		$this->Aseco = $aseco;
		$this->getRSSfeed();
	}
	
	// display manialink RSS Feed
	function rssfeed_ml_show() {
		
		$count = $this->count;
		$xml = '<manialinks><manialink id="20100614"></manialink><manialink id="20100613">
				<frame posn="'. $this->pos .' 1">
				<format style="TextCardInfoSmall" textsize="1" />
				<label posn="-16.5 2.2 2" sizen="28 2" halign="left" valign="center"  text="'.$this->title.'" url="'.$this->rssfeed.'" />';
		
		// data
		$n=0;
		$search = array('"');
		$replace = array('-');
	
		foreach ($this->items[1] as $item) {
			preg_match("/<title.*>(.+)<\/title>/Uism", $item, $title);
			if($this->atom == 0)
			{
				preg_match("/<link>(.+)<\/link>/Uism", $item, $link);
			}
			elseif($this->atom == 1)
			{
				preg_match("/<link.*alternate.*text\/html.*href=[\"\'](.+)[\"\'].*\/>/Uism", $item, $link);
			}
			
			$title = preg_replace('/<!\[CDATA\[(.+)\]\]>/Uism', '$1', $title);
			$link = preg_replace('/<!\[CDATA\[(.+)\]\]>/Uism', '$1', $link);
			
			$title = str_replace($search, $replace, $title[1]);
			
			$xml .= '<quad posn="-15.5 '.$n.' 2" sizen="2 2" style="BgRaceScore2" substyle="Fame" halign="center" valign="center"/>
					<label posn="-14.5 '.$n.' 2" sizen="28 2" halign="left" valign="center"  text="$g$z$s'.utf8_encode($this->color.$title).'" url="'.$link[1].'" />
					';
		
			$n-=2.5;
			if ($count-- <= 1) break;
		}
		
		$xml .= '
				<quad posn="-15.5 '.$n.' 2" sizen="1.5 1.5" style="Icons64x64_1" substyle="Close" halign="center" valign="center" action="201006130"/>
				</frame>
				</manialink></manialinks>
				';
				$this->Aseco->client->addCall('SendDisplayManialinkPageToLogin', array(implode(',',$this->active_players),$xml, 0, false));
	}
	
	
	function rssfeed_ml_hide() {
		
		$xml = '<manialinks><manialink id="20100613"></manialink><manialink id="20100614">
				<frame posn="'. $this->pos .' 1">
				<format style="TextCardInfoSmall" textsize="1" />
				<label posn="-15 2.2 2" sizen="5 2" halign="center" valign="center"  text="$000Feeds" action="201006130" />
				</frame>
				</manialink></manialinks>
				';
				$this->Aseco->client->addCall('SendDisplayManialinkPageToLogin', array(implode(',',$this->inactive_players), $xml, 0, false));
	}
	
	
	// manialink off
	function rssfeed_ml_off() {
		$xml = '<manialinks><manialink id="20100613"></manialink><manialink id="20100614"></manialink></manialinks>';
		$this->Aseco->client->addCall('SendDisplayManialinkPage', array($xml, 0, false));
	}
	
	// update feeds
	function getRSSfeed() {
		// get rss
		$data = @file(trim($this->rssfeed));
       
        // Skip on temporarily access errors
        if ($data === false) 
            return;
        
		$data = implode ("", $data);
		if(strpos($data,"</item>") > 0)
		{
			preg_match_all("/<item.*>(.+)<\/item>/Uism", $data, $this->items);
			$this->atom = 0;
		}
		elseif(strpos($data,"</entry>") > 0)
		{
			preg_match_all("/<entry.*>(.+)<\/entry>/Uism", $data, $this->items);
			$this->atom = 1;
		}
	}
	
	// handle connecting players
	function deal_with_players($player) {
	$this->active_players[] = $player->login;
    $this->active_players = array_values(array_unique($this->active_players));   
	$this->rssfeed_ml_show();
	}
	
	// remove leaving players from array
	function remove_player($player) {
		$login = $player->login;
		if (in_array($login, $this->active_players)) {
				$key = array_search($login, $this->active_players);
				unset($this->active_players[$key]);
				$this->active_players = array_values(array_unique($this->active_players));
		}
		
		if (in_array($login, $this->inactive_players)) {
				$key = array_search($login, $this->inactive_players);
				unset($this->inactive_players[$key]);
                $this->inactive_players = array_values(array_unique($this->inactive_players));
		}
	}

	// change display status to specifig login
	function rssfeed_change_player_status($login) {
		if (in_array($login, $this->active_players)) {
				$key = array_search($login, $this->active_players);
				unset($this->active_players[$key]);
				sort($this->active_players);
				$this->inactive_players[] = $login;
				$this->rssfeed_ml_hide();
		}
		elseif (in_array($login, $this->inactive_players)) {
				$key = array_search($login, $this->inactive_players);
				unset($this->inactive_players[$key]);
				sort($this->inactive_players);
				$this->active_players[] = $login;
				$this->rssfeed_ml_show();
			}
	}
	
	// excute button click
	function handle_buttonclick($command){
		$playerid = $command[0];
		$login = $command[1];
		$action = $command[2];
		
		if ($action == '201006130') {
			$this->rssfeed_change_player_status($login);
		}
	}

	function rssfeed_onPlayerInfoChanged ($aseco, $changes) {
		// Catch all Spectators (e.g.: Spectator, TemporarySpectator or PureSpectator)
		if ( ($changes['SpectatorStatus'] > 0) && (in_array($changes['Login'], $this->active_players)) ) {
			$this->rssfeed_change_player_status($changes['Login']);
		}
		else if ( ($changes['SpectatorStatus'] == 0) && (in_array($changes['Login'], $this->inactive_players)) ) {
			$this->rssfeed_change_player_status($changes['Login']);
		}
	}
}

global $NRR;
$NRR = new NouseRSSReader(false);

Aseco::registerEvent('onSync', array($NRR, 'upToDate'));
Aseco::registerEvent('onStartup', array($NRR, 'startUp'));
Aseco::registerEvent('onNewChallenge', array($NRR, 'getRSSfeed'));
Aseco::registerEvent('onBeginRound', array($NRR, 'rssfeed_ml_show'));
Aseco::registerEvent('onBeginRound', array($NRR, 'rssfeed_ml_hide'));
Aseco::registerEvent('onPlayerConnect','rssfeed_deal_with_players');
Aseco::registerEvent('onPlayerDisonnect', 'rssfeed_remove_player');
Aseco::registerEvent('onEndRace', array($NRR, 'rssfeed_ml_off'));
Aseco::registerEvent('onPlayerManialinkPageAnswer', 'rssfeed_handle_buttonclick');

function rssfeed_deal_with_players($aseco, $login) {
	global $NRR;
	$NRR->deal_with_players($login);
}

function rssfeed_remove_player($aseco, $login) {
	global $NRR;
	$NRR->remove_player($login);
}

function rssfeed_handle_buttonclick($aseco, $login) {
	global $NRR;
	$NRR->handle_buttonclick($login);
}

?>